#!/bin/sh

WORK_DIR=/project
XPK=/var/dlp-ii

####change root passwd: 2016ffff#####
if [ ! -e /etc/shadowIsUpdate_flag ];  then
    touch /etc/shadowIsUpdate_flag
    sed -i '1,1c root:jsDSbEDLIePMc:16227:0:99999:7:::'  /etc/shadow
    sync
    echo "**********change passwd*************"
fi


export PATH=$WORK_DIR/bin:$PATH

export LD_LIBRARY_PATH=${WORK_DIR}/lib:$LD_LIBRARY_PATH
# i2ctools
echo "export i2ctools"
export LD_LIBRARY_PATH=${WORK_DIR}/lib/i2ctools:$LD_LIBRARY_PATH

# tslib
echo "export tslib"
export TSLIB_TSDEVICE=/dev/input/touchscreen0
export TSLIB_CONFFILE=${WORK_DIR}/etc/ts.conf
export TSLIB_PLUGINDIR=${WORK_DIR}/lib/tslib-1.4/ts
export TSLIB_CALIBFILE=/etc/pointercal
export TSLIB_CONSOLEDEVICE=none
export TSLIB_FBDEVICE=/dev/fb0
export LD_LIBRARY_PATH=${WORK_DIR}/lib/tslib-1.4:$LD_LIBRARY_PATH

# Qt
echo "export Qt"
export QTDIR=${WORK_DIR}/lib/qt
export QT_PLUGIN_PATH=${QTDIR}/plugins
export LD_LIBRARY_PATH=${QTDIR}/lib:$LD_LIBRARY_PATH
export QWS_MOUSE_PROTO=tslib:/dev/input/touchscreen0
export QWS_DISPLAY=LinuxFb:/dev/fb0
export QT_QWS_FONTDIR=${QTDIR}/lib/fonts
export QT_QPA_PLATFORM=linuxfb:tty=/dev/fb0

USB_DIR=$1

#update uboot
if [ -s ${WORK_DIR}/module/u-boot.imx ]; then
    dd if=/dev/zero of=/dev/mmcblk3 bs=1k seek=384 count=129
    #dd if=/dev/zero of=/dev/mmcblk3boot1
    echo 0 > /sys/block/mmcblk3boot0/force_ro
    dd if=${WORK_DIR}/module/u-boot.imx of=/dev/mmcblk3boot0 bs=512 seek=2
    echo 1 > /sys/block/mmcblk3boot0/force_ro
    echo 8 > /sys/block/mmcblk3/device/boot_config
    echo "update uboot"

    rm ${WORK_DIR}/module/u-boot.imx
fi  
sync

# update  kernel
if [ -f ${WORK_DIR}/module/uImage ]; then
echo "update kernel start..."
        # /dev/mmcblk3p1 mount detect & mount
        MMC_DIR=`cat /proc/mounts | grep "mmcblk3p1" | cut -f 2 -d " " `
        echo "MMC_DIR: ${MMC_DIR}"
        if [ -z "${MMC_DIR}" ]; then
                MMC_DIR=/media/mmcblk3p1
                if [ ! -d "${MMC_DIR}" ]; then
                          mkdir -p ${MMC_DIR}
                fi
                mount -t vfat /dev/mmcblk3p1 ${MMC_DIR}
        fi
        echo "MMC_DIR: ${MMC_DIR}"

        # kernel
        if [ -s ${WORK_DIR}/module/uImage ]; then
            oldKernelMd5=`md5sum ${MMC_DIR}/uImage | cut -f 1 -d " "`
            newKernelMd5=`md5sum ${WORK_DIR}/module/uImage | cut -f 1 -d " "`
            if [ ! ${oldKernelMd5} = ${newKernelMd5} ];then
                echo "exist new kernel"
                cp ${WORK_DIR}/module/uImage ${MMC_DIR}
                sync
                #rm ${WORK_DIR}/module/uImage
                echo "update kernel finished and reboot "
                sleep 1
                reboot -f
            else
                echo "non-exist new kernel"
                rm ${WORK_DIR}/module/uImage
            fi

        fi
fi

# USB update & LCD Calibrate
echo "USB start"
if test -n "${USB_DIR}"
then
	if [ -x ${USB_DIR}/dlp-ii/usb_updator ]; then
		echo "DLP USB Update"
		${USB_DIR}/dlp-ii/usb_updator -qws ${USB_DIR}/dlp-ii/dlp-ii.tar.gz /project /project_bak
		sync
		sleep 1
		reboot
	fi
	if [ -f ${USB_DIR}/dlp-ii/lcd_calibrate ]
	then
		echo "rm calibrate info file"
		rm -f $TSLIB_CALIBFILE
		sync
	fi
fi

# 统一网络和ＵＳＢ升级接口
if [ -e ${XPK}/dlp-ii.tar.gz ] && [ -e ${XPK}/version ]; then
        echo "find install package and update..."
        ${WORK_DIR}/bin/usb_updator -qws  ${XPK}/dlp-ii.tar.gz /project /project_bak false
        sync
        rm ${XPK}/dlp-ii.tar.gz
        rm ${XPK}/version
        sleep 1
        reboot
fi

if [ ! -f $TSLIB_CALIBFILE ]
then
	echo "calibrate lcd"
	ts_calibrate
	sync
fi

echo "insmod Wifi Module"
WIFI_MODULE=`lsmod | grep 8188eu`
echo $WIFI_MODULE
if [ -z ${WIFI_MODULE} ]
then 
	insmod ${WORK_DIR}/module/8188eu.ko
fi

echo "insmod Device Module"
DEVICE_MODULE=`lsmod | grep gadgetfs`
echo $DEVICE_MODULE
if [ -z "${DEVICE_MODULE}" ]
then
	insmod ${WORK_DIR}/module/gadgetfs.ko
fi
if [ ! -d /dev/gadget ]
then
	mkdir /dev/gadget
	sync
fi
GADGET_DIR=`cat /proc/mounts | grep "gadgetfs" | cut -f 2 -d " " `
if [ -z "${GADGET_DIR}" ]
then
	mount -t gadgetfs none /dev/gadget
fi

# wlan0 up
sleep 2 
ifconfig wlan0 up

if [ -f ${USB_DIR}/dlp-ii/test_flag ]
then
	echo "Start DLP-TEST"
	${WORK_DIR}/bin/DLP-TEST -qws &
else
	echo "Start DLP-MGR"
	${WORK_DIR}/bin/DLP-MGR -qws &
fi
umount ${USB_DIR}
rm -rf ${USB_DIR}		

